package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFWorkflowMapper;
import com.sa.ibiz.demo.demo.domain.WFWorkflow;
import com.sa.ibiz.demo.demo.service.WFWorkflowService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFWorkflowSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.MsgTemplateService;

/**
 * 实体[WFWorkflow] 服务对象接口实现
 */
@Service
public class WFWorkflowServiceImpl extends ServiceImplBase<WFWorkflowMapper, WFWorkflow> implements WFWorkflowService{

    @Autowired
    private MsgTemplateService remindmsgtemplService;

    @Resource
    private WFWorkflowMapper wfworkflowMapper;


    @Override
    public boolean create(WFWorkflow et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFWorkflow et){
        this.beforeUpdate(et);
		this.wfworkflowMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFWorkflow et){
		return et.getWfworkflowid();  
    }

    @Override
    public boolean getDraft(WFWorkflow et)  {
    if((!StringUtils.isEmpty(et.getRemindmsgtemplid())) && et.getRemindmsgtempl() == null){
            try {
                et.setRemindmsgtempl(remindmsgtemplService.getById(et.getRemindmsgtemplid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFWorkflow> listDefault(WFWorkflowSearchFilter filter) {
		return wfworkflowMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFWorkflow> searchDefault(WFWorkflowSearchFilter filter) {
		return wfworkflowMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfworkflowMapper.selectRow(sql);
    }

 }